using Application.Services.Database;
using FluentValidation;

namespace Application.Endpoints.Pacients.Profile;

public class PacientProfileValidation : AbstractValidator<PacientProfileDTO>
{
    private readonly IPacientRepository _pacientRepository;

    public PacientProfileValidation(IPacientRepository pacientRepository)
    {
        _pacientRepository = pacientRepository;

        RuleFor(x => x.Email)
            .NotEmpty().WithMessage("Email is required.")
            .EmailAddress().WithMessage("Invalid email format.")
            .MustAsync(BeUniqueEmail).WithMessage("Email in use by another pacient.");

        RuleFor(x => x.Password)
            .NotEmpty().WithMessage("Password is required.")
            .MinimumLength(8).WithMessage("Password must be at least 8 characters long.");

        RuleFor(x => x.Name)
            .NotEmpty().WithMessage("Name is required.")
            .MinimumLength(3).WithMessage("Name must be at least 3 characters long.");

        RuleFor(x => x.Description)
            .MaximumLength(3000).WithMessage("Description must not exceed 3000 characters.");
    }

    private async Task<bool> BeUniqueEmail(string email, CancellationToken cancellationToken)
    {
        var pacient = await _pacientRepository.FindByEmailAsync(email);
        if (pacient != null)
        {
            return pacient.Email.Equals(email, StringComparison.OrdinalIgnoreCase);
        }
        return pacient == null;
    }
}
